

(function(ext) {
    var device = null;
    var _rxBuf = [];

   
	var data = [];

	ext.resetAll = function(){};
	
	ext.runArduino = function(){
		responseValue();
	};
	
	
	
	ext.WriteByte = function(Byte){
		var bytes = [];
		bytes.push(Byte);
    	device.send(bytes);
    };
	ext.ReadByte = function(nextID){
		
    	responseValue(nextID,data);
    };
	
    function processData(bytes) {
		data = bytes;
    }
	

    // Extension API interactions
    var potentialDevices = [];
    ext._deviceConnected = function(dev) {
        potentialDevices.push(dev);

        if (!device) {
            tryNextDevice();
        }
    }

    function tryNextDevice() {
        // If potentialDevices is empty, device will be undefined.
        // That will get us back here next time a device is connected.
        device = potentialDevices.shift();
        if (device) {
            device.open({ stopBits: 0, bitRate: 115200, ctsFlowControl: 0 }, deviceOpened);
        }
    }

    var watchdog = null;
    function deviceOpened(dev) {
        if (!dev) {
            // Opening the port failed.
            tryNextDevice();
            return;
        }
        device.set_receive_handler('motor',function(data) {
            processData(data);
        });
    };

    ext._deviceRemoved = function(dev) {
        if(device != dev) return;
        device = null;
    };

    ext._shutdown = function() {
        if(device) device.close();
        device = null;
    };

    ext._getStatus = function() {
        if(!device) return {status: 1, msg: 'motor disconnected'};
        if(watchdog) return {status: 1, msg: 'Probing for motor'};
        return {status: 2, msg: 'motor connected'};
    }

    var descriptor = {};
	ScratchExtensions.register('vBot', descriptor, ext, {type: 'serial'});
})({});
