#ifndef _L298PMOTORSHIELD_H_
#define _L298PMOTORSHIELD_H_

#include <Arduino.h>

#include <SoftwareSerial.h>

#define FALSE 0
#define TRUE 1

class L298PMotorShield{
  public:
    //public methods
    L298PMotorShield();
    void defaultSetting();

    void setM1Speed(int speed);
    void setM2Speed(int speed);
    void setSpeeds(int m1speed, int m2speed);

  	float getDistance();

  	void setBuzzerSound(bool);


  private:
	  unsigned char BT_TX;
	  unsigned char BT_RX;

	  unsigned char _BUZZER;

	  unsigned char _Trig;
	  unsigned char _Echo;

	  unsigned char servoPin;

	  unsigned char _INA; //1번 모터 Enable
	  unsigned char _PWMA; //1번 모터 pwm
	  unsigned char _INB; //2번 모터 Enable
	  unsigned char _PWMB; //2번 모터 pwm
};

#endif
